From fc872406bbd025626a2eff23d3fee6a2e7196d02 Mon Sep 17 00:00:00 2001
From: David Malcolm <dmalcolm@redhat.com>
Date: Wed, 31 Oct 2018 21:48:30 -0400
Subject: [PATCH 52/83] FIXME: fixups

---
 current-comparison.txt | 57 --------------------------------------------------
 gcc/cp/parser.c        |  2 ++
 2 files changed, 2 insertions(+), 57 deletions(-)

diff --git a/current-comparison.txt b/current-comparison.txt
index 1d5814b..59a4bc1 100644
--- a/current-comparison.txt
+++ b/current-comparison.txt
@@ -52,15 +52,6 @@ Tests changing outcome in gcc/testsuite/g++/g++.sum: 89
  PASS -> FAIL : g++.dg/cpp2a/bitfield1.C  -std=gnu++14 (test for excess errors)
  PASS -> FAIL : g++.dg/cpp2a/bitfield1.C  -std=gnu++17 (test for excess errors)
  PASS -> FAIL : g++.dg/ext/builtin9.C  -std=gnu++98 (test for excess errors)
- PASS -> FAIL : g++.dg/gomp/member-2.C  -std=gnu++14 (test for excess errors)
- PASS -> FAIL : g++.dg/gomp/member-2.C  -std=gnu++17 (test for excess errors)
- PASS -> FAIL : g++.dg/gomp/member-2.C  -std=gnu++98 (test for excess errors)
- PASS -> FAIL : g++.dg/gomp/udr-2.C  -std=gnu++14 (test for excess errors)
- PASS -> FAIL : g++.dg/gomp/udr-2.C  -std=gnu++17 (test for excess errors)
- PASS -> FAIL : g++.dg/gomp/udr-2.C  -std=gnu++98 (test for excess errors)
- PASS -> FAIL : g++.dg/gomp/udr-3.C  -std=gnu++14 (test for excess errors)
- PASS -> FAIL : g++.dg/gomp/udr-3.C  -std=gnu++17 (test for excess errors)
- PASS -> FAIL : g++.dg/gomp/udr-3.C  -std=gnu++98 (test for excess errors)
  PASS -> FAIL : g++.dg/inherit/virtual11.C  -std=gnu++14  scan-tree-dump-not gimple "OBJ_TYPE_REF"
  PASS -> FAIL : g++.dg/inherit/virtual11.C  -std=gnu++17  scan-tree-dump-not gimple "OBJ_TYPE_REF"
  PASS -> FAIL : g++.dg/inherit/virtual11.C  -std=gnu++98  scan-tree-dump-not gimple "OBJ_TYPE_REF"
@@ -98,51 +89,3 @@ Tests changing outcome in gcc/testsuite/g++/g++.sum: 89
  PASS -> FAIL : g++.old-deja/g++.warn/impint2.C  -std=gnu++17  (test for warnings, line 45)
  PASS -> FAIL : g++.old-deja/g++.warn/impint2.C  -std=gnu++98  (test for warnings, line 44)
  PASS -> FAIL : g++.old-deja/g++.warn/impint2.C  -std=gnu++98  (test for warnings, line 45)
-
-Tests that went away in x86_64-pc-linux-gnu/libgomp/testsuite/libgomp.sum: PASS: 12
------------------------------------------------------------------------------------
-
- PASS: libgomp.c++/reduction-10.C execution test
- PASS: libgomp.c++/reduction-12.C execution test
- PASS: libgomp.c++/reduction-6.C execution test
- PASS: libgomp.c++/reduction-8.C execution test
- PASS: libgomp.c++/udr-1.C execution test
- PASS: libgomp.c++/udr-11.C execution test
- PASS: libgomp.c++/udr-13.C execution test
- PASS: libgomp.c++/udr-16.C execution test
- PASS: libgomp.c++/udr-17.C execution test
- PASS: libgomp.c++/udr-3.C execution test
- PASS: libgomp.c++/udr-6.C execution test
- PASS: libgomp.c++/udr-7.C execution test
-
-Tests appeared in x86_64-pc-linux-gnu/libgomp/testsuite/libgomp.sum: UNRESOLVED: 12
------------------------------------------------------------------------------------
-
- UNRESOLVED: libgomp.c++/reduction-10.C compilation failed to produce executable
- UNRESOLVED: libgomp.c++/reduction-12.C compilation failed to produce executable
- UNRESOLVED: libgomp.c++/reduction-6.C compilation failed to produce executable
- UNRESOLVED: libgomp.c++/reduction-8.C compilation failed to produce executable
- UNRESOLVED: libgomp.c++/udr-1.C compilation failed to produce executable
- UNRESOLVED: libgomp.c++/udr-11.C compilation failed to produce executable
- UNRESOLVED: libgomp.c++/udr-13.C compilation failed to produce executable
- UNRESOLVED: libgomp.c++/udr-16.C compilation failed to produce executable
- UNRESOLVED: libgomp.c++/udr-17.C compilation failed to produce executable
- UNRESOLVED: libgomp.c++/udr-3.C compilation failed to produce executable
- UNRESOLVED: libgomp.c++/udr-6.C compilation failed to produce executable
- UNRESOLVED: libgomp.c++/udr-7.C compilation failed to produce executable
-
-Tests changing outcome in x86_64-pc-linux-gnu/libgomp/testsuite/libgomp.sum: 12
--------------------------------------------------------------------------------
-
- PASS -> FAIL : libgomp.c++/reduction-10.C (test for excess errors)
- PASS -> FAIL : libgomp.c++/reduction-12.C (test for excess errors)
- PASS -> FAIL : libgomp.c++/reduction-6.C (test for excess errors)
- PASS -> FAIL : libgomp.c++/reduction-8.C (test for excess errors)
- PASS -> FAIL : libgomp.c++/udr-1.C (test for excess errors)
- PASS -> FAIL : libgomp.c++/udr-11.C (test for excess errors)
- PASS -> FAIL : libgomp.c++/udr-13.C (test for excess errors)
- PASS -> FAIL : libgomp.c++/udr-16.C (test for excess errors)
- PASS -> FAIL : libgomp.c++/udr-17.C (test for excess errors)
- PASS -> FAIL : libgomp.c++/udr-3.C (test for excess errors)
- PASS -> FAIL : libgomp.c++/udr-6.C (test for excess errors)
- PASS -> FAIL : libgomp.c++/udr-7.C (test for excess errors)
diff --git a/gcc/cp/parser.c b/gcc/cp/parser.c
index f1e3d37..172abf1 100644
--- a/gcc/cp/parser.c
+++ b/gcc/cp/parser.c
@@ -37666,6 +37666,8 @@ cp_parser_omp_declare_reduction_exprs (tree fndecl, cp_parser *parser)
       else
 	{
 	  cp_parser_parse_tentatively (parser);
+	  /* Don't create location wrapper nodes here.  */
+	  auto_suppress_location_wrappers sentinel;
 	  tree fn_name = cp_parser_id_expression (parser, /*template_p=*/false,
 						  /*check_dependency_p=*/true,
 						  /*template_p=*/NULL,
-- 
1.8.5.3